| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoTransformManip Class Reference
Manipulator Classes

The SoTransformManip class is used to manipulate transformations.A manipulator is used by replacing the node you want to edit in the graph with the manipulator. Draggers are used to to manipulate the node. When manipulation is finished, the node is put back into the graph, replacing the manipulator. More...

`#include <Inventor/manips/SoTransformManip.h>`

Inheritance diagram for SoTransformManip:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoTransformManip (void)
SoDragger * | getDragger (void)
SbBool | replaceNode (SoPath *p)
SbBool | replaceManip (SoPath *p, SoTransform *newone) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoTransform
| SoTransform (void)
void | pointAt (const SbVec3f &frompoint, const SbVec3f &topoint)
void | getScaleSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | getRotationSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | getTranslationSpaceMatrix (SbMatrix &mat, SbMatrix &inv) const
void | multLeft (const SbMatrix &mat)
void | multRight (const SbMatrix &mat)
void | combineLeft (SoTransformation *nodeonright)
void | combineRight (SoTransformation *nodeonleft)
void | setMatrix (const SbMatrix &mat)
void | recenter (const SbVec3f &newcenter)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoTransform
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoTransformation
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTransformManip (void)
void | setDragger (SoDragger *newdragger)
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
void | attachSensors (const SbBool onoff)
Protected Member Functions inherited from SoTransform
virtual | ~SoTransform ()
Protected Member Functions inherited from SoTransformation
| SoTransformation (void)
virtual | ~SoTransformation ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static void | transferFieldValues (const SoTransform *from, SoTransform *to)
static void | valueChangedCB (void *f, SoDragger *d)
static void | fieldSensorCB (void *f, SoSensor *d)
Static Protected Member Functions inherited from SoTransform
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTransformation
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)

## Protected Attributes

SoFieldSensor * | rotateFieldSensor
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor
SoFieldSensor * | centerFieldSensor
SoFieldSensor * | scaleOrientFieldSensor
SoChildList * | children

## Additional Inherited Members

Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }
Public Attributes inherited from SoTransform
SoSFVec3f | translation
SoSFRotation | rotation
SoSFVec3f | scaleFactor
SoSFRotation | scaleOrientation
SoSFVec3f | center
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTransformManip class is used to manipulate transformations.

A manipulator is used by replacing the node you want to edit in the graph with the manipulator. Draggers are used to to manipulate the node. When manipulation is finished, the node is put back into the graph, replacing the manipulator.

The SoTransformManip class is an abstract class which should not be used directly – use one of it's subclasses.

## Constructor & Destructor Documentation

SoTransformManip::SoTransformManip | ( | void | ) |  |

The constructor.

SoTransformManip::~SoTransformManip | ( | void | ) |  |

protectedvirtual

The destructor.

## Member Function Documentation

SoType SoTransformManip::getTypeId | ( | void | ) |  | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoTransform.

Reimplemented in SoCenterballManip, SoHandleBoxManip, SoJackManip, SoTabBoxManip, SoTrackballManip, SoTransformBoxManip, and SoTransformerManip.

const SoFieldData * SoTransformManip::getFieldData | ( | void | ) |  | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTransform.

Reimplemented in SoCenterballManip, SoHandleBoxManip, SoJackManip, SoTabBoxManip, SoTrackballManip, SoTransformBoxManip, and SoTransformerManip.

SoDragger * SoTransformManip::getDragger | ( | void | ) |  |

Returns the dragger used by this manipulator.

SbBool SoTransformManip::replaceNode | ( | SoPath * | path) |  |

Replaces a node at the tail end of path with this manipulator. The node must be an instance of a node class derived from SoTransform.

The manipulator will when inserted automatically copy the field data from the node, to make it initially affect the state in the same way as the node.

Returns `TRUE` if successful, and `FALSE` if the given node could not be replaced with the manipulator. The operation will for instance fail if the tail node of the given path is not of SoTransform type, or for any other condition where it is not possible to replace the node with this manipulator.

SbBool SoTransformManip::replaceManip | ( | SoPath * | path,
|  | SoTransform * | newone
| ) |  | const

Replaces this manipulator from the position specified by path with newnode. If newnode is `NULL`, an SoTransform will be created for you.

void SoTransformManip::doAction | ( | SoAction * | action) |  |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoTransform.

void SoTransformManip::callback | ( | SoCallbackAction * | action) |  |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoTransform.

void SoTransformManip::GLRender | ( | SoGLRenderAction * | action) |  |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoTransform.

void SoTransformManip::getBoundingBox | ( | SoGetBoundingBoxAction * | action) |  |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoTransform.

void SoTransformManip::getMatrix | ( | SoGetMatrixAction * | action) |  |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoTransform.

void SoTransformManip::handleEvent | ( | SoHandleEventAction * | action) |  |

virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also overrides this method.

Reimplemented from SoNode.

void SoTransformManip::pick | ( | SoPickAction * | action) |  |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoTransform.

void SoTransformManip::search | ( | SoSearchAction * | action) |  |

virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See Also
  SoSearchAction

Reimplemented from SoNode.

SoChildList * SoTransformManip::getChildren | ( | void | ) |  | const

virtual

Returns the children of this node. This node only has the dragger as a child.

Reimplemented from SoNode.

void SoTransformManip::setDragger | ( | SoDragger * | newdragger) |  |

protected

Sets up the dragger instance to be controlled by this manipulator.

void SoTransformManip::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |

protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoNode.

void SoTransformManip::transferFieldValues | ( | const SoTransform * | from,
|  | SoTransform * | to
| ) |  |

staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Copies field values from one node to the other.

void SoTransformManip::valueChangedCB | ( | void * | m,
|  | SoDragger * | dragger
| ) |  |

staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Callback to update field values when motion matrix changes.

void SoTransformManip::fieldSensorCB | ( | void * | m,
|  | SoSensor * | d
| ) |  |

staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Callback to update motion matrix when a field is modified.

void SoTransformManip::attachSensors | ( | const SbBool | onoff) |  |

protected

Can be used by subclasses to attach/detach field sensors.

## Member Data Documentation

SoFieldSensor * SoTransformManip::rotateFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::translFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::scaleFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::centerFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::scaleOrientFieldSensor

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoChildList * SoTransformManip::children

protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoTransformManip.h
- SoTransformManip.cpp
- commoncode.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.